// weigus EVCS simulator (weigu.lu) 

#include "rapi_proc.h" // remote API processor

float sleep_blink_freq = 0.2;
byte sleep_flag = 0;
byte evcs_state = EVCS_STATE_A;
char text_buffer[30];


void setup() {
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH);
  RapiInit();  
}

void loop() {
  switch (nb_delay_x3((unsigned long)(500.0/sleep_blink_freq), 10000, 400)) {
    case 1:
      if (sleep_flag == 1) {
        toggle_led(LED_BUILTIN);
      }  
      break;
    case 2:
      evcs_state++;
      if (evcs_state==4) {
        evcs_state= EVCS_STATE_A;
      }
      sprintf(text_buffer,"$ST %02d\n",evcs_state);
      Serial1.write(text_buffer);
      break;
    case 3:
      
      break;
    case 0:
      break;
  }
  RapiDoCmd();   
  delay(20); // Time needed to get serial
}

bool nb_delay(unsigned long milliseconds) {
  static unsigned long nb_delay_prev_time {0};
  if(millis() >= nb_delay_prev_time + milliseconds) {
    nb_delay_prev_time += milliseconds;
    return true;
  }
  else {
    return false;
  }
}

byte nb_delay_x3(unsigned long ms_1, unsigned long ms_2, unsigned long ms_3) {
  static unsigned long nb_delay_prev_time_1 = 0;
  static unsigned long nb_delay_prev_time_2 = 0;
  static unsigned long nb_delay_prev_time_3 = 0;
  unsigned long millis_now = millis();
  if(millis_now >= nb_delay_prev_time_1 + ms_1) {
    nb_delay_prev_time_1 += ms_1;
    return 1;
  }
  if(millis_now >= nb_delay_prev_time_2 + ms_2) {
    nb_delay_prev_time_2 += ms_2;
    return 2;
  }
  if(millis_now >= nb_delay_prev_time_3 + ms_3) {
    nb_delay_prev_time_3 += ms_3;
    return 3;
  }
  return 0;
}

void toggle_led(byte pin) {
  if (digitalRead(pin)) {
    digitalWrite(pin, LOW);
  }
  else {
    digitalWrite(pin, HIGH);
  }
}
